"use strict";

var _slicedToArray = function (arr, i) { if (Array.isArray(arr)) { return arr; } else { var _arr = []; for (var _iterator = arr[Symbol.iterator](), _step; !(_step = _iterator.next()).done;) { _arr.push(_step.value); if (i && _arr.length === i) break; } return _arr; } };

function hexToSegments(numOfSegments, hex) {
  var segments = repeat(numOfSegments, 0);
  return segments.map(function (_, i) {
    return hex >> i & 1;
  });
}

function rgb(color) {
  return rgba(color, 1);
}

function rgba(color, alpha) {
  var _color = _slicedToArray(color, 3);

  var r = _color[0];
  var g = _color[1];
  var b = _color[2];
  return "rgba(" + (r || 0) + ", " + (g || 0) + ", " + (b || 0) + ", " + alpha + ")";
}

function toCharArr(value) {
  return (value.toString() || "").split("");
}

function padArr(ch, n, xs) {
  var max = Math.max(n - xs.length, 0);
  var pad = repeat(max, ch);
  return pad.concat(xs);
}

function repeat(n, val) {
  var xs = new Array(n);
  for (var i = 0; i < n; i++) {
    xs[i] = val;
  }
  return xs;
}

module.exports = {
  hexToSegments: hexToSegments,
  padArr: padArr,
  repeat: repeat,
  rgb: rgb,
  rgba: rgba,
  toCharArr: toCharArr };